require_relative 'player'
#require_relative 'die'
require_relative 'game_turn'
require_relative 'treasure_trove'
require 'csv'
module StudioGame
    class Game
      attr_reader :title

       def initialize(title)
         @title=title
         @players=[]#define an instance variable called @players that starts off as an empty array.
       end

       def add_player(a_player)
         @players.push(a_player)
       end

       def play(rounds)
         puts "There are #{@players.size} players in #{@title}"
         @players.each do |player|
           puts player
         end

         treasures = TreasureTrove::TREASURES
         puts "\nThere are #{treasures.size} treasures to find."
         treasures.each do |treasure|
           puts "A #{treasure.name} is worth #{treasure.points} points."
         end

         1.upto(rounds) do |round|
           if block_given?
             break if yield
           end
             puts "\nRound #{round}:"
            @players.each do |player|
              GameTurn.take_turn(player)
              puts player
           end
         end
       end

       def print_name_and_health(player)
         puts "#{player.name} (#{player.health})"
       end

       def total_points
         @players.reduce(0) { |sum, player| sum + player.points }
       end

       def high_score_entry(player)
         formatted_name = player.name.ljust(20, '-')
         "#{formatted_name} #{player.score}"
       end

       def print_stats
         strong_players, wimpy_players = @players.partition {|player| player.strong?}
         puts "\n#{@title} Statistics:"

         puts "\n#{strong_players.size} strong players:"
         strong_players.each do |player|
           print_name_and_health(player)
         end

         puts "\n#{wimpy_players.size} wimpy players:"
         wimpy_players.each do |player|
           print_name_and_health(player)
          end

         puts "\n#{total_points} total points from treasures found"

          @players.sort.each do |player|
           puts "\n#{player.name}'s point totals:"
           player.each_found_treasure do |treasure|
             puts "#{treasure.points} total #{treasure.name} points"
           end
           puts "#{player.points} grand total points"
         end

         puts "\n#{@title} High Scores:"
         @players.sort.each do |player|
          puts high_score_entry(player)
         end
       end
         #def load_players(from_file)
           #File.readlines(from_file).each do |line|
             #add_player(Player.from_csv(line))
             #puts line
           #end
         #end

         def load_players(from_file)
             #File.readlines(from_file).each do |line|
              # add_player(Player.from_csv(line))

             CSV.foreach(from_file) do |row|
               player = Player.new(row[0], row[1].to_i)
               add_player(player)

               #puts line
              #name, health = line.split(',')
              #player = Player.new(name, Integer(health))
              #add_player(player)

             end
         end

         def save_high_scores(to_file="high_scores.txt")
           File.open(to_file, "w") do |file|
             file.puts "#{@title} High Scores:"
             @players.sort.each do |player|
               file.puts high_score_entry(player)
             end
           end
         end




    end # left of this last end!!!!!!

    if __FILE__ ==$0
    player=Player.new("moe")
    puts player.name
    puts player.health
    player.w00t
    puts player.health
    player.blam
    puts "well that just sux!"
    puts player.health
    end
end
